unit Ausgabe;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  Feld, Schlange, Haeppchen, LCLType;

type

  { TForm1 }

  TForm1 = class(TForm)
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Timer1Timer(Sender: TObject);
    procedure pruefen;
    procedure ende;
    procedure fressen1;
    procedure fressen2;
    procedure Kollision;
    procedure Umsetzen1;
    procedure Umsetzen2;
  private
    Punkte: integer;
    Field: TFeld;
    Snake: TSchlange;
    Happen: THaeppchen;
    bx: integer;
    lx: integer;
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  Snake:= TSchlange.Create;
  Snake.Canvas:= Self.Canvas;
  Happen:= THaeppchen.Create;
  Happen.FCanvas:= Self.Canvas;
  Snake.Init;
  Self.DoubleBuffered:= true;
  Field:= TFeld.Create;
  Field.Canvas:= Self.Canvas;
  bx:= 3;

  //Koordinaten von 2 bis 35 bzw. 25 festlegen
  Randomize;
  Happen.Haeppchen1.x:= Random(35)+2;
  Happen.Haeppchen1.y:= Random(25)+2;
  Happen.Haeppchen2.x:= Random(35)+2;
  Happen.Haeppchen2.y:= Random(25)+2;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState
  );
begin

  //Taste W
  if Key = VK_W then
  begin
    if bx = 1 then
    begin
      Snake.AendereRichtung(1);
    end
    else
    begin
      Snake.AendereRichtung(0);
      bx:= 0;
    end;
  end;

  //Taste S
  if Key = VK_S then
  begin
    if bx = 0 then
    begin
      Snake.AendereRichtung(0);
    end
    else
    begin
      Snake.AendereRichtung(1);
      bx:= 1;
    end;
  end;

  //Taste A
  if Key = VK_A then
  begin
    if bx = 3 then
    begin
      Snake.AendereRichtung(3);
    end
    else
    begin
      Snake.AendereRichtung(2);
      bx:= 2;
    end;
  end;

  //Taste D
  if Key = VK_D then
  begin
    if bx = 2 then
    begin
      Snake.AendereRichtung(2);
    end
    else
    begin
      Snake.AendereRichtung(3);
      bx:= 3;
    end;
  end;

end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin

  Snake.Update;
  Field.WandBauen;

  //Hintergrundfarbe setzen
  Self.Canvas.Brush.Color:= Field.Farbe;
  Self.Canvas.Rectangle(0, 0, ClientWidth, ClientHeight);

  Snake.Render;
  Field.Render;

  //Ersten Happen setzen
  Self.Canvas.Pen.Color:= clWhite;
  Self.Canvas.Brush.Color:= clWhite;
  Self.Canvas.Ellipse(Happen.Haeppchen1.x * 16,Happen.Haeppchen1.y * 16,Happen.Haeppchen1.x * 16 + 16,Happen.Haeppchen1.y * 16 + 16);

  //Zweiten Happen setzen
  Self.Canvas.Pen.Color:= clWhite;
  Self.Canvas.Brush.Color:= clWhite;
  Self.Canvas.Ellipse(Happen.Haeppchen2.x * 16,Happen.Haeppchen2.y * 16,Happen.Haeppchen2.x * 16 + 16,Happen.Haeppchen2.y * 16 + 16);

    //Rechnen und Wachsen
    if(Snake.FTeile[0].x = Happen.Haeppchen1.x) and (Snake.FTeile[0].y = Happen.Haeppchen1.y) then
    begin
      fressen1;
{    end
    else
    begin
      //Prüfen ob Happen auf Schlange
      repeat
        Happen.Haeppchen1.x:= Random(35)+2;
        Happen.Haeppchen1.y:= Random(25)+2;
      until not Snake.IsOnPoint(Happen.Haeppchen1);}
    end;

    //Rechnen und Wachsen
    if(Snake.FTeile[0].x = Happen.Haeppchen2.x) and (Snake.FTeile[0].y = Happen.Haeppchen2.y) then
    begin
      fressen2;
{    end
    else
    begin
      //Prüfen ob Happen auf Schlange
      repeat
        Happen.Haeppchen2.x:= Random(35)+2;
        Happen.Haeppchen2.y:= Random(25)+2;
      until not Snake.IsOnPoint(Happen.Haeppchen2);}
    end;

  //Prüfen ob Happen auf Mauer
  if Assigned (Field.Waende[Happen.Haeppchen1.x][Happen.Haeppchen1.y]) then
  begin
    Umsetzen1;
  end;

  if Assigned (Field.Waende[Happen.Haeppchen2.x][Happen.Haeppchen2.y]) then
  begin
    Umsetzen2;
  end;

  //Level
  if (Punkte >= 0) and (Punkte < 25) then
  begin
    Caption:='Snake - Level 1 ' + IntToStr(Punkte) + ' Pkt';
    Timer1.Interval:= 250;
  end;

  if (Punkte >= 25) and (Punkte < 50) then
  begin
    Caption:='Snake - Level 2 ' + IntToStr(Punkte) + ' Pkt';
    Timer1.Interval:= 200;
  end;

  if (Punkte >= 50) and (Punkte < 75) then
  begin
    Caption:='Snake - Level 3 ' + IntToStr(Punkte) + ' Pkt';
    Timer1.Interval:= 150;
  end;

  if (Punkte >= 75) and (Punkte < 100) then
  begin
    Caption:='Snake - Level 4 ' + IntToStr(Punkte) + ' Pkt';
    Timer1.Interval:= 100;
  end;

  if (Punkte >= 100) and (Punkte < 125) then
  begin
    Caption:='Snake - Level 5 ' + IntToStr(Punkte) + ' Pkt';
    Timer1.Interval:= 50;
  end;

  if (Punkte >= 125) and (Punkte < 150) then
  begin
    Caption:='Snake - Level 6 ' + IntToStr(Punkte) + ' Pkt';
    Timer1.Interval:= 30;
  end;

  //SpielEnde
  if Punkte >=150 then
  begin
    ende;
  end;

  //Wandkollision
  if Assigned (Field.Waende[Snake.FTeile[0].x][Snake.FTeile[0].y]) then
  begin
    Kollision;
  end;

  //Selber beißen
  if Snake.PruefeObTot then
  begin
    pruefen;
  end;

end;

procedure TForm1.pruefen;
begin

  Timer1.Enabled:= false;
  ShowMessage('Sie sind tot! Erreichte Punkte: ' + IntToStr(Punkte));
  lx:= MessageDlg('Erneut spielen?', mtInformation, [mbYes, mbNo], 0);
  if lx = mrYes then
  begin
    bx:= 3;
    Snake.Init;
    Snake.Render;
    Punkte:= 0;
    Timer1.Enabled:= true;
    Timer1.Interval:= 250;
    Randomize;
{    Happen.Haeppchen1.x:= Random(35)+1;
    Happen.Haeppchen1.y:= Random(25)+1;
    Happen.Haeppchen2.x:= Random(35)+1;
    Happen.Haeppchen2.y:= Random(25)+1;}
  end
  else
  begin
    Close;
  end;
end;

procedure TForm1.ende;
begin

  lx:= MessageDlg('Glückwunsch Spiel Beendet! Erneut Spielen?', mtInformation, [mbYes, mbNo], 0);
  if lx = mrYes then
  begin
    bx:= 3;
    Snake.Init;
    Snake.Render;
    Punkte:= 0;
    Timer1.Enabled:= true;
    Timer1.Interval:= 250;
    Randomize;
{    Happen.Haeppchen1.x:= Random(35)+1;
    Happen.Haeppchen1.y:= Random(25)+1;
    Happen.Haeppchen2.x:= Random(35)+1;
    Happen.Haeppchen2.y:= Random(25)+1;}
  end;
end;

procedure TForm1.fressen1;
begin
  Punkte:= Punkte + 1;
  Snake.WachseUm1;
  Caption:= '+1';
  repeat
    Happen.Haeppchen1.x:= Random(35)+2;
    Happen.Haeppchen1.y:= Random(25)+2;
  until not Snake.IsOnPoint(Happen.Haeppchen1);
end;

procedure TForm1.fressen2;
begin
  Punkte:= Punkte + 1;
  Snake.WachseUm1;
  Caption:= '+1';
  repeat
    Happen.Haeppchen2.x:= Random(35)+2;
    Happen.Haeppchen2.y:= Random(25)+2;
  until not Snake.IsOnPoint(Happen.Haeppchen2);
end;

procedure TForm1.Kollision;
begin

  Timer1.Enabled:= false;
  lx:= MessageDlg('Game Over! Möchten Sie erneut spielen?', mtInformation, [mbYes, mbNo], 0);
  if lx = mrYes then
  begin
    bx:= 3;
    Snake.Init;
    Snake.Render;
    Punkte:= 0;
    Timer1.Enabled:= true;
    Timer1.Interval:= 250;
    Randomize;
{    Happen.Haeppchen1.x:= Random(35)+2;
    Happen.Haeppchen1.y:= Random(25)+2;
    Happen.Haeppchen2.x:= Random(35)+2;
    Happen.Haeppchen2.y:= Random(25)+2;  }
  end
  else
  begin
    Close;
  end;
end;

procedure TForm1.Umsetzen1;
begin
  Self.Canvas.Pen.Color:= clWhite;
  Self.Canvas.Brush.Color:= clWhite;
  Self.Canvas.Ellipse(Happen.Haeppchen1.x * 16,Happen.Haeppchen1.y * 16,Happen.Haeppchen1.x * 16 + 16,Happen.Haeppchen1.y * 16 + 16);
end;

procedure TForm1.Umsetzen2;
begin
  Self.Canvas.Pen.Color:= clWhite;
  Self.Canvas.Brush.Color:= clWhite;
  Self.Canvas.Ellipse(Happen.Haeppchen2.x * 16,Happen.Haeppchen2.y * 16,Happen.Haeppchen2.x * 16 + 16,Happen.Haeppchen2.y * 16 + 16);
end;

end.

